#version 330 
precision highp float;

layout(triangles) in;
layout (triangle_strip, max_vertices=3) out;

in VertexData
{
	vec3 position;
    vec2 texCoord;
    vec3 normal;
} VertexIn[];
 
out VertexData
{
	vec3 position;
    vec2 texCoord;
    vec3 normal;
	vec3 weight;
} VertexOut;

uniform mat4 ViewMatrix; // Viewport matrix
out vec4 vertex_color;

 void main()
{
	VertexOut.normal = VertexIn[0].normal;
	VertexOut.position = VertexIn[0].position;
	VertexOut.texCoord = VertexIn[0].texCoord;
	gl_Position = gl_in[0].gl_Position;
	EmitVertex();
	
	VertexOut.weight = vec3(0.0, 1.0, 0.0);
	VertexOut.normal = VertexIn[1].normal;
	VertexOut.position = VertexIn[1].position;
	VertexOut.texCoord = VertexIn[1].texCoord;
	gl_Position = gl_in[1].gl_Position;
	EmitVertex();
	
	VertexOut.weight = vec3(0.0, 0.0, 1.0);
	VertexOut.normal = VertexIn[2].normal;
	VertexOut.position = VertexIn[2].position;
	VertexOut.texCoord = VertexIn[2].texCoord;
	gl_Position = gl_in[2].gl_Position;
	EmitVertex();
	
	EndPrimitive();
}