#version 330 compatibility

layout (location = 0) in vec3 VertexPosition;
layout (location = 1) in vec3 VertexTexCoord;
layout (location = 2) in vec3 VertexNormal;
 
out VertexData
{
	vec3 position;
    vec3 texCoord;
    vec3 normal;
} VertexOut;
 
uniform mat4 MVP;
uniform mat4 ModelViewMatrix;
uniform mat3 NormalMatrix;

void main()
{
    VertexOut.position = vec3(ModelViewMatrix * vec4(VertexPosition,1.0));
    VertexOut.texCoord = VertexTexCoord;
    VertexOut.normal = normalize(NormalMatrix * VertexNormal);
    gl_Position = MVP * vec4(VertexPosition,1.0);
}