#version 330
#extension GL_EXT_geometry_shader4 : enable

layout( points ) in;
layout( line_strip, max_vertices = 2 ) out;

in VertexData
{
	vec4 position;
	vec3 normal;
} VertexIn[];

out Data
{
    vec4 color;
} gdata;

uniform float normLengthFaktor;
uniform mat4 ProjectionMatrix;
uniform vec4 firstColour;
uniform vec4 secondColour;

out Data
{
	vec2 textureCoords;
} TexCoord;

void main()
{
	mat4 m = ProjectionMatrix; // Reassign for brevity	

    gl_Position = m * VertexIn[0].position;
	gdata.color = firstColour;
	EmitVertex();

	gl_Position = m * (VertexIn[0].position + vec4(VertexIn[0].normal*normLengthFaktor,0.0));
	gdata.color = secondColour;
	EmitVertex();

    EndPrimitive();
}