#version 330
#extension GL_EXT_geometry_shader4 : enable

layout( points ) in;
layout( triangle_strip, max_vertices = 4 ) out;

in VertexData
{
	vec4 position;
} VertexIn[];


uniform float Size2; // Half the width of the quad
uniform mat4 ProjectionMatrix;
out Data
{
	vec2 textureCoords;
} TexCoord;

void main()
{
	mat4 m = ProjectionMatrix; // Reassign for brevity
	
	gl_Position = m * (vec4(-Size2,-Size2,0.0,0.0) +
	VertexIn[0].position);
	TexCoord.textureCoords = vec2(0.0,0.0);
	EmitVertex();
	
	gl_Position = m * (vec4(Size2,-Size2,0.0,0.0) +
	VertexIn[0].position);
	TexCoord.textureCoords = vec2(1.0,0.0);
	EmitVertex();
	
	gl_Position = m * (vec4(-Size2,Size2,0.0,0.0) +
	VertexIn[0].position);
	TexCoord.textureCoords = vec2(0.0,1.0);
	EmitVertex();
	
	gl_Position = m * (vec4(Size2,Size2,0.0,0.0) +
	VertexIn[0].position);
	TexCoord.textureCoords = vec2(1.0,1.0);
	EmitVertex();

    EndPrimitive();
}