#version 330

precision highp float;

smooth in vec2 vTexCoord;
out vec4 vFragColor;

uniform sampler2D leftTextureMap;
uniform sampler2D rightTextureMap;

void main(void)
{
	// Half-Color Anaglyphen red right green left
	// vec3 cleft = texture2D(leftTextureMap, vec2(vTexCoord)).xyz;
	// vec3 cright = texture2D(rightTextureMap, vec2(vTexCoord)).xyz;
	// vFragColor.r = 0.7*cleft.g + 0.3*cleft.b;            //ohne Gammakorrektur
	// //vFragColor.r = pow(0.7*cleft.g + 0.3*cleft.b, 1.5);  //mit Gammakorrektur
	// vFragColor.g = cright.g;
	// vFragColor.b = cright.b;
	// vFragColor.w = 1.0;


	// anglyph left red green right
	vec4 leftFrag = texture(leftTextureMap, vTexCoord);
	leftFrag = vec4(1.0, leftFrag.g, leftFrag.b, 1.0); // Left eye is full red and actual green and blue
	 
	vec4 rightFrag = texture(rightTextureMap, vTexCoord);
	rightFrag = vec4(rightFrag.r, 1.0, 1.0, 1.0); // Right eye is full green and blue and actual red
	 
	// Multiply left and right components for final ourput colour
	vFragColor = vec4(leftFrag.rgb * rightFrag.rgb, 1.0);

	// //green/magenta
	// vec4 leftFrag = texture(leftTextureMap, vTexCoord);
	// leftFrag = vec4(1.0, leftFrag.g, leftFrag.b, 1.0); // Left eye is full red and actual green and blue
	 
	// vec4 rightFrag = texture(rightTextureMap, vTexCoord);
	// rightFrag = vec4(rightFrag.r, 1.0, 1.0, 1.0); // Right eye is full green and blue and actual red
	// vFragColor = vec4(rightFrag.r, leftFrag.g, rightFrag.b, 1.0);
	
	// //ColorCode 3D
	// vec4 leftFrag = texture(leftTextureMap, vTexCoord);
	// leftFrag = vec4(1.0, leftFrag.g, leftFrag.b, 1.0); // Left eye is full red and actual green and blue
	 
	// vec4 rightFrag = texture(rightTextureMap, vTexCoord);
	// rightFrag = vec4(rightFrag.r, 1.0, 1.0, 1.0); // Right eye is full green and blue and actual red
	// vec3 coefficient = vec3(0.15, 0.15, 0.7);
 
	// // Take the dot product of the right-eye colour components and specified coefficients
	// float mixedRightFrag = dot(rightFrag.rgb, coefficient);
	 
	// // Final colour output
	// vFragColor = vec4(leftFrag.r, leftFrag.g, mixedRightFrag, 1.0);
}