#version 330
in vec2 TexCoord;
in vec3 Normal;
out vec4 FragColor;

uniform sampler2D textureMap;
uniform mat4 MVP;

void main(void)
{
	vec3 norm = normalize( Normal );
	
	// Distance to the light
	float dist = 3;
	
	vec3 s = normalize(vec4(vec4(1.0,1.0,1.0,1.0)).xyz);
	
	float pLightAtt =1 / (1.0 + 0.2*dist + 0.2*dist*dist);
	
	// Direction of the light (from the fragment to the light)
	float cosTheta = dot(norm,s);
	float fFactor = clamp( cosTheta, 0.f , 1.f );
	
	vec3 diff= pLightAtt * vec3(1.0,1.0,1.0) * fFactor;	
	vec3 amb = vec3(0.5,0.5,0.5);


	vec4 texCol = texture(textureMap, TexCoord);

	FragColor += vec4(amb+diff, 1.0)*texCol;
}
