#version 330

layout (location = 0) in vec3 VertexPosition;
layout (location = 1) in vec2 VertexTexCoord;
layout (location = 2) in vec3 VertexNormal;

out vec2 TexCoord;
out vec3 Normal;

uniform mat4 MVP;
uniform mat3 NormalMatrix;
uniform mat4 ModelViewMatrix;

void main()
{
	TexCoord = VertexTexCoord;
	gl_Position = MVP*vec4(VertexPosition,1);
	
	// Normal of the the vertex, in camera space
	Normal = NormalMatrix * vec4(VertexNormal,0).xyz;
}
